package main

import (
	"cr-launcher/utils"
	"fmt"
	"os/exec"
	"path"
)

func main() {

	config, err := utils.ReadConfig()
	if err != nil {
		fmt.Println("配置文件错误")
		return
	}
	url := ""
	if config != nil {
		url = config.Url
	}

	version, err := utils.GetLatest(url)
	if err != nil {
		fmt.Println("获取版本信息错误")
		return
	}

	// 服务器最新版本有变动 更新
	if version.Version != config.Version {
		// 下载
		utils.DownloadZip(version.Url)
		// 解压
		fmt.Println("更新")
		fileName := path.Base(version.Url)
		err := utils.Unzip(fileName)
		if err != nil {
			fmt.Println(err)
			return
		}
		// 替换版本
		err = utils.WriteConfig(&utils.Config{
			Version: version.Version,
			Url:     config.Url,
			ExePath: config.ExePath,
		})
		if err != nil {
			fmt.Println(err)
			fmt.Println("配置写入失败")
		}
	}
	// 运行应用程序
	cmd := exec.Command(config.ExePath)
	data, err := cmd.Output()
	if err != nil {
		fmt.Println(err)
		fmt.Println("启动失败")
		return
	}
	fmt.Println(string(data))
	fmt.Println("启动成功")
}
